// PIXIE_III_WB.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "PIXIE_III_WB.h"
#ifdef CAD_TEST
	#include "vpi_user.h"
#endif
#include "MainFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CPIXIE_III_WBApp

BEGIN_MESSAGE_MAP(CPIXIE_III_WBApp, CWinApp)
END_MESSAGE_MAP()


// CPIXIE_III_WBApp construction

CPIXIE_III_WBApp::CPIXIE_III_WBApp()
{
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;
	SetAppID(_T("Pixie_III_WB.AppID.NoVersion"));
}


CPIXIE_III_WBApp theApp;


BOOL CPIXIE_III_WBApp::InitInstance()
{
	#ifdef CAD_TEST
		vpi_printf("InitInstance starts ... \n");
	#else
		TRACE("InitInstance starts ... \n");
	#endif
	InitCommonControls();
	CWinApp::InitInstance();
	SetRegistryKey(_T("PIXIE 3 WorkBench"));
	CMainFrame* pFrame = new CMainFrame;
	if(!pFrame)
		return FALSE;
	m_pMainWnd = pFrame;
	BOOL rslt_LoadFrame = pFrame->LoadFrame(IDR_MAINFRAME, WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL, NULL);
	#ifdef CAD_TEST
		vpi_printf("InitInstance LoadFrame\tLast error: %d\n", GetLastError());
	#else
		TRACE("InitInstance LoadFrame\tLast error: %d\n", GetLastError());
	#endif
	BOOL rslt_ShowWindow = pFrame->ShowWindow(SW_SHOWNORMAL);
	#ifdef CAD_TEST
		vpi_printf("InitInstance ShowWindow\tLast error: %d\n", GetLastError());
	#else
		TRACE("InitInstance ShowWindow\tLast error: %d\n", GetLastError());
	#endif
	pFrame->UpdateWindow();
	#ifdef CAD_TEST
		vpi_printf("InitInstance finishes ... \n\n");
	#else
		TRACE("InitInstance finishes ... \n\n");
	#endif

	return TRUE;
}

#ifdef CAD_TEST
PLI_INT32 vpi_Initialize_WB(PLI_BYTE8 *user_data)
{
	vpi_printf("Inside of vpi_CreateWindow\n");
	return 0;
}

void vpit_RegisterTfs( void )
{
    s_vpi_systf_data systf_data;
    vpiHandle        systf_handle;

    systf_data.type        = vpiSysTask;
    systf_data.sysfunctype = 0;
    systf_data.tfname      = "$init_Pixie_III_WB";
    systf_data.calltf      = vpi_Initialize_WB;
    systf_data.compiletf   = 0;
    systf_data.sizetf      = 0;
    systf_data.user_data   = 0;
    systf_handle = vpi_register_systf( &systf_data );
    vpi_free_object( systf_handle );
}

void (*vlog_startup_routines[])() = {
    vpit_RegisterTfs,
    0
};
#endif